#include <stdio.h>
#include <stdlib.h>
#include <windows.h> 
#include "wspecgraf.h"

WSpecGraf::WSpecGraf()
{
	clrScr();
	setCursorType(_NOCURSOR);
}

WSpecGraf::~WSpecGraf()
{
	setCursorType(_NORMALCURSOR);	
}

void WSpecGraf::clrScr() 
{ 
	system("cls"); 
}


void WSpecGraf::gotoXY(int x, int y) 
{ 
	HANDLE hConsoleOutput; 
	COORD dwCursorPosition; 

	dwCursorPosition.X = x - 1; 
	dwCursorPosition.Y = y - 1; 
	hConsoleOutput = GetStdHandle(STD_OUTPUT_HANDLE); 
	SetConsoleCursorPosition(hConsoleOutput, dwCursorPosition);
} 

typedef enum {_NORMALCURSOR, _NOCURSOR} cur_type;
void WSpecGraf::setCursorType(cur_type ct)
{
	HANDLE hConsoleOutput; 
	hConsoleOutput = GetStdHandle(STD_OUTPUT_HANDLE); 
	CONSOLE_CURSOR_INFO ci;
	GetConsoleCursorInfo(hConsoleOutput, &ci);
	switch(ct)
	{
		case _NORMALCURSOR:
			ci.bVisible = true;
			break;
		case _NOCURSOR:
			ci.bVisible = false;
			break;
	}		
	SetConsoleCursorInfo(hConsoleOutput, &ci);
}


void WSpecGraf::set(int y, int x, int dy, int dx, int nbins, float min_val, float max_val)
{
//	text_info ti;
//	gettextinfo(&ti);

	int max_x, max_y;
//	max_x = ti.screenwidth;
//	max_y = ti.screenheight;   // Windows sets this value to 300 and scrolls the window
	max_x = 80;
	max_y = 25;

	if(dy == -1)
		dy = max_y + 1;
	if(dx == -1)
		dx = max_x + 1;
	
	this->x = x;
	this->y = y;
	this->dx = dx;
	this->dy = dy;
	this->max_val = max_val;
	this->min_val = min_val;
	this->nbins = nbins;
	
	stx = dx / nbins;
	if(stx < 1)
		stx = 1;
	
	sty = (max_val - min_val) / dy;
}

void WSpecGraf::show(float *data)
{
//	clrscr();
	int i, j, k, off_x = 0;
	for(i = 0; i < nbins; i++)
	{
		for(j = 0; j < stx; j++)
		{
			float v = (data[i] - min_val) / sty;
			int max = (int)(v + 0.5f);
			if(max < 0)
				max = 0;
			if(max > dy)
				max = dy;
			for(k = 0; k <= max; k++)
			{
				gotoXY(off_x + x + 1, dy - k + y - 2 + 1);
				printf("^");
			}
			for(k = max + 1; k <= dy; k++)
			{
				gotoXY(off_x + x + 1, dy - k + y - 2 + 1);
				printf(" ");
			}
			off_x++;
		}
	}
}


